;TIP1045D.LSP:  XYZ2TAG.LSP     Attribute Utilities     (C)1994, Robert L. Zipprich

(DEFUN TXTVALU ( W X Y ) ; creates a prompt with a default STRING
   (setq X1 (strcat W X Y)) (prompt X1)
(setq X2 (strcase (getstring))) (if (eq X2 "") (set Y1 X) (set Y1 X2)))
;------------------------------------------------------
(defun C:XYZ2TAG ()
   (prompt "\nCopies coordinates of a block into one of its own attributes.")
   (if (eq TAGNAME2 nil) (setq TAGNAME2 "COORDS")) (set 'Y1 'TAGNAME2)
   (TXTVALU "\nTag name for Coords----<" TAGNAME2 ">: ")
   (setq TAGNAME1 TAGNAME2)

   (Setq BLK1     (car (entsel "Select Block: "))
      DATA1    (entget BLK1)
      BLKNAME1 (cdr (assoc 2 DATA1))
   )

   (if (eq ANSWER nil) (setq ANSWER "S")) (set 'Y1 'ANSWER)
   (TXTVALU "\nSingle or Global?------<" ANSWER ">: ")

   (cond
      ; if single block
      ((eq "S" ANSWER)
         (progn
            (setq BLK BLK1 DATA DATA1)
            (single)
      ))

      ; if global search
      ((eq "G" ANSWER)
         (progn
            (setq BLK1 (entnext))                             ;first dwg entity
            (while (/= BLK1 nil)
               (setq  DATA1    (entget BLK1)
                  BLKNAME2 (cdr (assoc 2 DATA1))           ;entity name
               )
               (if (eq BLKNAME2 BLKNAME1)                  ;compare with test block
                  (progn
                     (prompt ".")
                     (setq BLK BLK1 DATA DATA1)
                     (single)
                     (setq BLK1 (entnext BLK1))             ;find next block
                  )   ;end progn this entity
                  ;else
                  (setq BLK1 (entnext BLK1))               ;if no block match
               ) ;end if
            )     ;end while not eof
      ))
   ) ;end cond
   (prompt "\nAll Done.")
   (princ)
) ; end xyz2tag
;------------------------------------------------------
(defun SINGLE ()
   (setq PT          (cdr (assoc 10 DATA))
      XCOORD      (rtos (car PT) 2 4)
      YCOORD      (rtos (cadr PT) 2 4)
      ZCOORD      (rtos (car (cdr (cdr PT))) 2 4)
      COORDS      (strcat XCOORD "," YCOORD "," ZCOORD)
      ATTR1       (entnext BLK)
      DATA        (entget ATTR1)
   )

   (while (/= "SEQEND" (cdr (assoc 0 DATA)))

      (if (eq TAGNAME1 (cdr (assoc 2 DATA)))
         (progn
            (Setq DATA (subst (cons 1 COORDS) (assoc 1 DATA) DATA))
            (entmod DATA)
            (entupd ATTR1)
         )
      )
      (setq ATTR1 (entnext ATTR1)
         DATA  (entget ATTR1)
      )
   )
) ;end single
(princ); end xyz2tag.lsp
